package org.dromara.biz.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.biz.domain.bo.BizGuideBo;
import org.dromara.biz.domain.vo.BizGuideVo;
import org.dromara.biz.domain.BizGuide;
import org.dromara.biz.mapper.BizGuideMapper;
import org.dromara.biz.service.IBizGuideService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 办事指南Service业务层处理
 *
 * @author Blue
 * @date 2025-05-09
 */
@RequiredArgsConstructor
@Service
public class BizGuideServiceImpl implements IBizGuideService {

    private final BizGuideMapper baseMapper;

    /**
     * 查询办事指南
     *
     * @param id 主键
     * @return 办事指南
     */
    @Override
    public BizGuideVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询办事指南列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 办事指南分页列表
     */
    @Override
    public TableDataInfo<BizGuideVo> queryPageList(BizGuideBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<BizGuide> lqw = buildQueryWrapper(bo);
        Page<BizGuideVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的办事指南列表
     *
     * @param bo 查询条件
     * @return 办事指南列表
     */
    @Override
    public List<BizGuideVo> queryList(BizGuideBo bo) {
        LambdaQueryWrapper<BizGuide> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<BizGuide> buildQueryWrapper(BizGuideBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<BizGuide> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(BizGuide::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getCategory()), BizGuide::getCategory, bo.getCategory());
        lqw.eq(StringUtils.isNotBlank(bo.getCategoryNo()), BizGuide::getCategoryNo, bo.getCategoryNo());
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), BizGuide::getTitle, bo.getTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), BizGuide::getContent, bo.getContent());
        lqw.eq(StringUtils.isNotBlank(bo.getFile()), BizGuide::getFile, bo.getFile());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), BizGuide::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增办事指南
     *
     * @param bo 办事指南
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(BizGuideBo bo) {
        BizGuide add = MapstructUtils.convert(bo, BizGuide.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改办事指南
     *
     * @param bo 办事指南
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(BizGuideBo bo) {
        BizGuide update = MapstructUtils.convert(bo, BizGuide.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(BizGuide entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除办事指南信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
